###############################################################################
# RecentPostsBarAdmin.pl                                                      #
###############################################################################
# RecentPostsBarAdmin.pl for YaBB2
#
# Version:        1.2
#
# Released:       January, 13, 2006
#
# Distributed by: http://www.boardmod.com
#
# =========================================================================== #
# Software by: Ferazel2001 (Devon Stewart)
#
# Changelog:
#
# Version 1
# - Originally for YaBB 1.3
#
# Version 1.1
# - Ported to YaBB2
# - More customization available
# - Fixed bar size, (no longer a percentage)
#
# Version 1.2
# - Made the Color preferences customizable by Admins only
# - Added a "Quick Minimize" bar
# - Fixed a couple of bugs from 1.1
#
###############################################################################

$recentpostsplver = 'RecentPostsBarAdmin.pl $Revision: 1.1 $';

LoadLanguage("recent_post_bar");

if ($action eq 'detailedversion') { return 1; }

sub setGlobalVars
{
$defaults[0] = "15";
$defaults[1] = "on";
$defaults[2] = "$defaults_txt{'2'}";
$defaults[3] = "$defaults_txt{'3'}";
$defaults[4] = "$defaults_txt{'4'}";
$defaults[5] = "";
$defaults[6] = "$defaults_txt{'6'}";
$defaults[7] = "0";
$defaults[8] = "off";
$defaults[9] = "on";
$defaults[10] = "$defaults_txt{'10'}";
$indexNum = 11;
$BoardWatchDesc = "$admin_txt{'14'}";
}

sub prefs
{
    &setGlobalVars;
    if (!(-e "$memberdir/\ Global.recentposts"))
    {
	&resetGlobalPrefs;
    }
    &readGlobalPrefs;

    if($RESET eq "on")
    {$RESETcheck = "checked";}
    else{$RESETcheck = "";}

    if($RPBusersCanModifyHexColors eq "on")
    {$RPBusersCanModifyHexColorsChecked = "checked";}
    else{$RPBusersCanModifyHexColorsChecked = "";}

    if($RPBcolorchange eq "on")
    {$RPBcolorchangecheck = "checked";}
    else{$RPBcolorchangecheck = "";}

    $yytitle = "$admin_txt{'13'}";
$yymain =qq~
<br>

<table border="0" width="100%" cellspacing="0" class="bordercolor" align="center" height="0">
    <td class="bordercolor" width="100%">
      <table width="100%" cellspacing="0" cellpadding="2">
        <tr>
          <td class="titlebg" width="558"><font size="2"><img src="$imagesdir/preferences.gif" alt="" border="0" /><b>$admin_txt{'1'}</b></font>
          </td>
        </tr>
      </table>
    </td>
</table>
<form action="$adminurl?action=recentpostprefs2" method="post">

<table class="bordercolor" cellspacing="1" cellpadding="2">
	<tr class="windowbg2">
		<td width="40%"><font size="2">$admin_txt{'2'}</td>
		<td width="25%"><input type=checkbox name=RESET $RESETcheck></td>
		<td><font size="1">[$defaults_txt{'9'}]</td>
	</tr>
	<tr class="windowbg2">
		<td><font size="2">$admin_txt{'3'}</td>
		<td><input type=input name=display size=5 value="$RPBdisplay"></td>
		<td><font size="1">[$defaults[0]]</td>
	</tr>
	<tr class="windowbg2">
		<td><font size="2">$admin_txt{'4'}</td>
		<td><input type=checkbox name=colorchange $RPBcolorchangecheck></td>
		<td><font size="1">[$defaults_txt{'1'}]</td>
	</tr>
	<tr class="windowbg2">
		<td><font size="2">$admin_txt{'5'}</td>
		<td><input type=input name=bgcolor size=6 value="$RPBbgcolor"></td>
		<td><font size="1">[$defaults[2]]</td>
	</tr>
	<tr class="windowbg2">
		<td><font size="2">$admin_txt{'6'}</td>
		<td><input type=input name=hlcolor size=6 value="$RPBhlcolor"></td>
		<td><font size="1">[$defaults[3]]</td>
	</tr>
	<tr class="windowbg2">
		<td><font size="2">$admin_txt{'7'}</td>
		<td><input type=input name=textcolor size=6 value="$RPBtextcolor"></td>
		<td><font size="1">[$defaults[4]]</td>
	</tr>
	<tr class="windowbg2">
		<td><font size="2">$admin_txt{'8'}</td>
		<td><input type=input name=boardwatch size=6 value="$RPBboardwatch"></td>
		<td><font size="1">[$BoardWatchDesc]</td>
	</tr>
	<tr class="windowbg2">
		<td><font size="2">$admin_txt{'9'}</td>
		<td><input type=input name=boardwatchColor size=6 value="$RPBboardwatchColor"></td>
		<td><font size="1">[$defaults[6]]</td>
	</tr>
	<tr class="windowbg2">
		<td><font size="2">$admin_txt{'10'}</td>
		<td><input type=checkbox name=usersCanModifyHexColors $RPBusersCanModifyHexColorsChecked></td>
		<td><font size="1">[$defaults_txt{'8'}]</td>
		</tr>
	<tr class="windowbg2">
		<td><font size="2">$admin_txt{'11'}</td>
		<td><input type=input name=RESETmessage size=26 value="$RESETmessage"></td>
		<td><font size="1">[$defaults[10]]</td>
	</tr>
	</table>
	
<table width="100%" class="bordercolor" cellspacing="1" cellpadding="2">
	<tr>
		<td class="titlebg"><br><br><center><input type=submit><br><br></td>
	</tr>
	<tr>
		<td class="windowbg2"><br><br><center><a href="$adminurl?action=recentpostreset">$admin_txt{'12'}</a><br><br></td>
	</tr>
</table>

</form>
~;

&AdminTemplate;
exit;
}

sub prefs2 {
if($FORM{'display'} eq "")
{
	$yySetLocation = qq~$adminurl?action=recentpostprefs~;
	&redirectexit;
}
    $RPBdisplay = $FORM{'display'};
    $RPBcolorchange = $FORM{'colorchange'};
    $RPBbgcolor = $FORM{'bgcolor'};
    $RPBhlcolor = $FORM{'hlcolor'};
    $RPBtextcolor = $FORM{'textcolor'};
    $RPBboardwatch = $FORM{'boardwatch'};
    $RPBboardwatchColor = $FORM{'boardwatchColor'};
    $RESET = $FORM{'RESET'};
    $RPBusersCanModifyHexColors = $FORM{'usersCanModifyHexColors'};
    $RESETmessage = $FORM{'RESETmessage'};

    $RESETmessage =~ s~"~'~g;
    
    if($RPBdisplay < 1){$RPBdisplay = 1;}
    if($RPBdisplay > 40){$RPBdisplay = 40;}

&writeGlobalPrefs;

	$yySetLocation = qq~$adminurl?action=recentpostprefs~;
	&redirectexit;
}

sub resetGlobalPrefs
{
    open(FILE, ">$memberdir/ Global.recentposts");
    print FILE qq~$defaults[0]
$defaults[1]
$defaults[2]
$defaults[3]
$defaults[4]
$defaults[5]
$defaults[6]
$defaults[7]
$defaults[8]
$defaults[9]
$defaults[10]
1
~;

    close(FILE);
}

sub readGlobalPrefs
{
    open(FILE, "$memberdir/ Global.recentposts");
    @prefFile = <FILE>;
    close(FILE);

    if($prefFile[$indexNum] != 1)
    {
    &resetGlobalPrefs;
    }

    $RPBdisplay = $prefFile[0];
    chomp $RPBdisplay;
    $RPBcolorchange = $prefFile[1];
    chomp $RPBcolorchange;
    $RPBbgcolor = $prefFile[2];
    chomp $RPBbgcolor;
    $RPBhlcolor = $prefFile[3];
    chomp $RPBhlcolor;
    $RPBtextcolor = $prefFile[4];
    chomp $RPBtextcolor;
    $RPBboardwatch = $prefFile[5];
    chomp $RPBboardwatch;
    $RPBboardwatchColor = $prefFile[6];
    chomp $RPBboardwatchColor;
    $RPBusersCanModifyHexColors = $prefFile[8];
    chomp $RPBusersCanModifyHexColors;
    $RESET = $prefFile[9];
    chomp $RESET;
    $RESETmessage = $prefFile[10];
    chomp $RESETmessage;
}

sub writeGlobalPrefs
{
open(FILE, ">$memberdir/\ Global.recentposts");
print FILE qq~$RPBdisplay
$RPBcolorchange
$RPBbgcolor
$RPBhlcolor
$RPBtextcolor
$RPBboardwatch
$RPBboardwatchColor
$indexNum
$RPBusersCanModifyHexColors
$RESET
$RESETmessage
1
~;
    close(FILE);
}

sub reset
{
	&setGlobalVars;
	&resetGlobalPrefs;
	$yySetLocation = qq~$adminurl?action=recentpostprefs~;
	&redirectexit;
}
1;