<id>
RecentPostsBar_1.2
</id>

<version>
1.2+
</version>

<mod info>
This mod adds a "Recent Posts Bar" on the right of any forum, the user can specify if he/she wants it (as it does take up space) and if they do, they can specify the number of recent posts it will display.

To Install:
-----------
- Put "RecentPostsBar.pl" into your Sources directory and chmod it 777
- Put "RecentPostsBarAdmin.pl" into your Admin directory and chmod it 777
- Install this mod either manually or with BoardMod (manually recommended)
- Explore the new "Recent Posts Bar" Admin Center addon
- Turn off the RESET checkbox (in the admin center) to enable users to have their own preference sets
- Enjoy!

Version History:
----------------

 Version 1.0
 - Originally for YaBB 1.3

 Version 1.1
 - Ported to YaBB2
 - More customization available
 - Fixed bar size, (no longer a percentage)

 Version 1.2
 - Overhauled the administrator abilities
 - Added a "Quick Minimize" bar
 - Fixed a couple of bugs from 1.1
 - Added the Admin Center frontend
 
 Version 1.2+
 - Edits done by JanS
 - Overhauled the layout to get a better table layout
 - Made Multilanguage
 - Added ModImages for folding and unfolding of the catsblock
 - cleaned up some html and pl

</mod info>

<author>
Ferazel2001 (Devon Stewart) multilanguage add-ons by JanS (Jan Snijder)
</author>

<homepage>
http://speakeasy.org/~devonst17/
</homepage>

<edit file>
Templates/default/default.html
</edit file>

<search for>
<yabb main>
</search for>

<replace>
<table width="100%" cellspacing="0" align="center">
	<tr>
		<td valign="TOP" width="*">
			<BR><yabb main><BR>
		</td>
		<yabb RecentPostsBar> 
	</tr>
</table>
</replace>

<edit file>
yabbfiles/Templates/Forum/default.css
</edit file>

<search for>
#container{
	background-color: #F2F6F9;
	width: 90%;
</search for>

<replace>
#container{
	background-color: #F2F6F9;
	width: 97%;
</replace>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
sub template {
</search for>

<replace>
sub template {
if(-e "$sourcedir/RecentPostsBar.pl")
{
	require "$sourcedir/RecentPostsBar.pl";
	&RecentPostsBar;
}
</replace>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
);
</search for>

<add before>
'recentpostprefs',"RecentPostsBar.pl&prefs",
'recentpostprefs2',"RecentPostsBar.pl&prefs2",
'recentposttoggle',"RecentPostsBar.pl&toggle",
'recentposthelp',"RecentPostsBar.pl&help",
</add before>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
);
</search for>

<add before>
'recentpostprefs',"RecentPostsBarAdmin.pl&prefs",
'recentpostprefs2',"RecentPostsBarAdmin.pl&prefs2",
'recentpostreset',"RecentPostsBarAdmin.pl&reset",
</add before>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$recent_posts_bar_mod = "Recent Posts Bar Mod|Ferazel2001 (Devon Stewart)& JanS (multilanguage add-on, and more.)|This mod adds a \"Recent Posts\" bar on the right of any forum, the user can specify if he/she wants it (as it does take up space) and if they do, they can specify the number of recent posts it will display.<br /><ul><u>JanS edits</u><br /><li>Added multilanguage support and the appropriate maps to go with it. <li>Added ModImages map with graphical arrows for folding and unfolding the table instead of using hex. valued symbols <li>Improved layout and style.<li>Credits for the original mod go to Ferazel2001, for the add-ons credits to JanS (Jan Snijder)</ul>|1.2+|01/22/06";
	push (@installed_mods, "$recent_posts_bar_mod");

</add before>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$recent_posts_bar = "recentpostprefs|Recent Posts Bar Preferences|Recent Posts Bar Mod|";
push (@boardmod_mods, "$recent_posts_bar");
</add before>