<id>
RecentPostsBar_1.2
</id>

<version>
1.2
</version>

<mod info>
This mod adds a "Recent Posts Bar" on the right of any forum, the user can specify if he/she wants it (as it does take up space) and if they do, they can specify the number of recent posts it will display.

To Install:
-----------
- Put "RecentPostsBar.pl" into your Sources directory and chmod it 777
- Put "RecentPostsBarAdmin.pl" into your Admin directory and chmod it 777
- Install this mod either manually or with BoardMod (manually recommended)
- Explore the new "Recent Posts Bar" Admin Center addon
- Turn off the RESET checkbox (in the admin center) to enable users to have their own preference sets
- Enjoy!

Version History:
----------------

 Version 1.0
 - Originally for YaBB 1.3

 Version 1.1
 - Ported to YaBB2
 - More customization available
 - Fixed bar size, (no longer a percentage)

 Version 1.2
 - Overhauled the administrator abilities
 - Added a "Quick Minimize" bar
 - Fixed a couple of bugs from 1.1
 - Added the Admin Center frontend

</mod info>

<author>
Ferazel2001 (Devon Stewart)
</author>

<homepage>
http://speakeasy.org/~devonst17/
</homepage>

################################# NON ADMIN MODIFICATIONS #################################

# Adds the <yabb RecentPostsBar> tag to the Template
<edit file>
Templates/default/default.html
</edit file>

<search for>
<yabb main>
</search for>

<replace>
<table width="100%" cellspacing="0" align="center">
	<tr>
		<td valign="TOP" width="*">
			<BR><yabb main><BR>
		</td>
		<yabb RecentPostsBar> 
	</tr>
</table>
</replace>

# Sets the width of the board to be a bit wider to allow more space for the bar
<edit file>
public_html/yabbfiles/Templates/Forum/default.css
</edit file>

<search for>
#container{
	background-color: #F2F6F9;
	width: 90%;
</search for>

<replace>
#container{
	background-color: #F2F6F9;
	width: 97%;
</replace>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
sub template {
</search for>

<replace>
sub template {
if(-e "$sourcedir/RecentPostsBar.pl")
{
	require "$sourcedir/RecentPostsBar.pl";
	&RecentPostsBar;
}
</replace>

<edit file>
Sources/SubsList.pl
</edit file>

<search for>
);
</search for>

<add before>
'recentpostprefs',"RecentPostsBar.pl&prefs",
'recentpostprefs2',"RecentPostsBar.pl&prefs2",
'recentposttoggle',"RecentPostsBar.pl&toggle",
'recentposthelp',"RecentPostsBar.pl&help",
</add before>


################################# ADMIN MODIFICATIONS #################################

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
);
</search for>

<add before>
'recentpostprefs',"RecentPostsBarAdmin.pl&prefs",
'recentpostprefs2',"RecentPostsBarAdmin.pl&prefs2",
'recentpostreset',"RecentPostsBarAdmin.pl&reset",
</add before>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$recent_posts_bar_mod = "Recent Posts Bar Mod|Ferazel2001 (Devon Stewart)|This mod adds a \"Recent Posts\" bar on the right of any forum, the user can specify if he/she wants it (as it does take up space) and if they do, they can specify the number of recent posts it will display.|1.2|01/13/06";
	push (@installed_mods, "$recent_posts_bar_mod");

</add before>

<edit file>
AdminIndex.pl
</edit file>

<search for>

### END BOARDMOD ANCHOR ###
</search for>

<add before>
$recent_posts_bar = "recentpostprefs|Recent Posts Bar Preferences|Recent Posts Bar Mod|";
push (@boardmod_mods, "$recent_posts_bar");
</add before>
